SHEBANG
# Copyright (C)2011 @BABOLO http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up.m4,v 1.2 2011/12/28 20:54:12 babolo Exp $

JNTROSTUP(ircd,,ircd-hybrid-rudnl
,dnl
# jailup ${inclass} dir jailname jailaddr [user [group]]
#     where dir relative to ${JAILUPDIR} and ${JAILRODIR}
#     default user=999005, default group=999005dnl
)

jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
user="${4:-999005}"
group="${5:-999005}"
port="${6:-9997}"
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"

${mkdir} "${main_dir}" "${conf_dir}"
${up_mdir} "${main_dir}" ${MTREE}
${up_mdir} "${conf_dir}" ${MTREE}-conf
  ${up_genlist} ircd-hybrid-ru/codepages/ ${MTREE}-conf                                               \
| ${up_data} "${conf_dir}/ircd-hybrid-ru/codepages/" "${PREFIX}/etc/ircd-hybrid-ru/codepages/"
  ${up_genlist} ircd-hybrid-ru/ ${MTREE}-conf                                                         \
| ${up_conf} "${conf_dir}/ircd-hybrid-ru/" "${PREFIX}/etc/ircd-hybrid-ru/"
  ${up_genlist} lib/ircd-hybrid-ru-modules/autoload/ ${MTREE}                                         \
| ${up_data} "${main_dir}/lib/ircd-hybrid-ru-modules/autoload/"                                       \
             "${PREFIX}/lib/ircd-hybrid-ru-modules/autoload/"
  ${up_genlist} lib/ircd-hybrid-ru-modules/ ${MTREE}                                                  \
| ${up_data} "${main_dir}/lib/ircd-hybrid-ru-modules/" "${PREFIX}/lib/ircd-hybrid-ru-modules/"
  ${up_genlist} help/opers/ ${MTREE}                                                                  \
| ${up_data} "${main_dir}/help/opers/" "${PREFIX}/help/opers/"
  ${up_genlist} help/users ${MTREE}                                                                   \
| ${up_data} "${main_dir}/help/users/" "${PREFIX}/help/users/"
ETCOPY(host.conf hosts resolv.conf)
${touch} "${main_dir}/var/log/gline"
${touch} "${main_dir}/var/log/kill"
${touch} "${main_dir}/var/log/kline"
${touch} "${main_dir}/var/log/oper"
${touch} "${main_dir}/var/log/user"
${up_libexe} "${main_dir}/libexec" << EOF
    ircd
EOF
echo "${main_dir}/libexec/ircd" | ${up_ldsh} | ${up_shlib} "${main_dir}/lib"
${up_genlist} lib/ircd-hybrid-ru-modules/ ${MTREE} | ${up_ldsh} | ${up_shlib} "${main_dir}/lib"
${up_genlist} lib/ircd-hybrid-ru-modules/autoload/ ${MTREE} | ${up_ldsh} | ${up_shlib} "${main_dir}/lib"

      #####################################
      ####                             ####
      #### Begin of etc fill           ####
      ####                             ####
${up_acc} gr "${conf_dir}" <<- EOF
	wheel:*:0:root
	nogroup:*:65533:
	nobody:*:65534:
	ircdru:*:${group}:
EOF

${up_acc} pwt "${conf_dir}" <<- EOF
	root:*:0:0::0:0:Charlie &:/:/dev/null/none
	nobody:*:65534:65534::0:0:Unprivileged user:/dev/null/none:/dev/null/none
	ircdru:*:${user}:${group}::0:0:IRCD:/:/dev/null/none
EOF

CONFCOPY(ircd-hybrid-ru/${genclass}.conf, "${TEMPLATE}")

${up_adc} "${etcdir}/newsyslog.conf" <<- EOF
	#${main_dir}/var/log/gline 	644  9     *	@01T00  Z ${main_dir}/var/run/ircd.pid
	#${main_dir}/var/log/kill 	644  9     *	@01T00  Z ${main_dir}/var/run/ircd.pid
	#${main_dir}/var/log/kline 	644  9     *	@01T00  Z ${main_dir}/var/run/ircd.pid
	#${main_dir}/var/log/oper 	644  9     *	@01T00  Z ${main_dir}/var/run/ircd.pid
	#${main_dir}/var/log/user 	644  9     *	@01T00  Z ${main_dir}/var/run/ircd.pid
EOF
      ####                             ####
      #### End of etc fill             ####
      ####                             ####
      #####################################

${mtree} -Ueqxp "${main_dir}" -f ${MTREE}
${mtree} -Ueqxp "${conf_dir}" -f ${MTREE}-conf
${pwd_mkdb} -d "${conf_dir}" -p "${conf_dir}/master.passwd"

${up_adc} "${JAILUPRC}" <<- EOF
	#${genclass}	${inclass}	${jdir}	${jailsname}	${jailsaddr}	0	${user}	${group}
EOF

      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${up_adc} "${etcdir}/fstab" <<- EOF
	#devfs			${main_dir}/dev	devfs	rw		0 0
	#${conf_dir}		${main_dir}/etc	nullfs	ro,noexec	0 0
EOF
      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
